csConfigFile Class Reference (Crystal Space 2.0 Public API Reference)

| ## Public API Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
csConfigFile Class Reference

Configuration file which implements the iConfigFile SCF interface. More...

`#include <csutil/cfgfile.h>`

Inheritance diagram for csConfigFile:

List of all members.

## Public Member Functions
virtual void | Clear ()
| Delete all options and rewind all iterators.
| csConfigFile (const char *Filename=0, iVFS *=0)
| Create a new configuration object from the given file.
| csConfigFile (iBase *)
| Create a new empty configuration object.
virtual void | DeleteKey (const char *Key)
| Delete a key and its comment.
virtual csPtr< iConfigIterator > | Enumerate (const char *Subsection=0)
| Enumerate selected keys.
virtual bool | GetBool (const char *Key, bool Def=false) const
| Get a boolean value from the configuration.
virtual const char * | GetComment (const char *Key) const
| Get the comment of the given key, or 0 if no comment exists.
virtual const char * | GetEOFComment () const
| return the final comment at the end of the configuration file
virtual const char * | GetFileName () const
| Get configuration file name.
virtual float | GetFloat (const char *Key, float Def=0.0) const
| Get a float value from the configuration.
virtual int | GetInt (const char *Key, int Def) const
| Get an integer value from the configuration.
virtual const char * | GetStr (const char *Key, const char *Def="") const
| Get a string value from the configuration.
virtual csPtr< iStringArray > | GetTuple (const char *Key) const
| Get a tuple set from the configuration.
virtual iVFS * | GetVFS () const
| Get the VFS object on which this file is stored (if any).
virtual bool | IsEmpty () const
| Is the configuration object empty?
virtual bool | KeyExists (const char *Key) const
| Test if a key exists.
virtual bool | Load (const char *iFileName, iVFS *=0, bool Merge=false, bool NewWins=true)
| Load a configuration file.
virtual void | LoadFromBuffer (const char *Filedata, bool overwrite)
| Load the configuration from a data buffer and add it to the current configuration.
virtual void | ParseCommandLine (iCommandLineParser *cmdline, iVFS *vfs, bool Merge=false, bool NewWins=true)
| Parse the command line for configuration options.
virtual bool | Save ()
| Save configuration to the same place from which it was loaded.
virtual bool | Save (const char *iFileName, iVFS *=0)
| Save configuration into the given file (on VFS or on the physical filesystem).
virtual void | SetBool (const char *Key, bool Value)
| Set a boolean value.
virtual bool | SetComment (const char *Key, const char *Text)
| Set the comment for given key.
virtual void | SetEOFComment (const char *Text)
| set the final comment at the end of the configuration file
virtual void | SetFileName (const char *, iVFS *)
| Set config file name.
virtual void | SetFloat (const char *Key, float Value)
| Set a floating-point value.
virtual void | SetInt (const char *Key, int Value)
| Set an integer value.
virtual void | SetStr (const char *Key, const char *Val)
| Set an null-terminated string value.
virtual void | SetTuple (const char *Key, iStringArray *Value)
| Set a tuple value.
virtual bool | SubsectionExists (const char *Subsection) const
| Test if at least one key exists with the given Subsection prefix.
virtual | ~csConfigFile ()
| Delete this configuration.

## Detailed Description

Configuration file which implements the iConfigFile SCF interface.

Definition at line 39 of file cfgfile.h.

## Constructor & Destructor Documentation

csConfigFile::csConfigFile | ( | const char * | Filename = `0`,
|  | iVFS * | = `0`
| ) |  |

Create a new configuration object from the given file.

csConfigFile::csConfigFile | ( | iBase * |  | ) |

Create a new empty configuration object.

virtual csConfigFile::~csConfigFile | ( |  | ) | `[virtual]`

Delete this configuration.

## Member Function Documentation

virtual void csConfigFile::Clear | ( |  | ) | `[virtual]`

Delete all options and rewind all iterators.

Implements iConfigFile.

virtual void csConfigFile::DeleteKey | ( | const char * | Key | ) | `[virtual]`

Delete a key and its comment.

Implements iConfigFile.

virtual csPtr<iConfigIterator> csConfigFile::Enumerate | ( | const char * | Subsection = `0` | ) | `[virtual]`

Enumerate selected keys.

If a subsection is given, only those keys which are prefixed by the subsection string will be enumerated. The returned iterator does not yet point to a valid key. You must call Next() to set it to the first key.

Implements iConfigFile.

virtual bool csConfigFile::GetBool | ( | const char * | Key,
|  | bool | Def = `false`
| ) |  | const`[virtual]`

Get a boolean value from the configuration.

Implements iConfigFile.

virtual const char* csConfigFile::GetComment | ( | const char * | Key | ) | const`[virtual]`

Get the comment of the given key, or 0 if no comment exists.

Implements iConfigFile.

virtual const char* csConfigFile::GetEOFComment | ( |  | ) | const`[virtual]`

return the final comment at the end of the configuration file

Implements iConfigFile.

virtual const char* csConfigFile::GetFileName | ( |  | ) | const`[virtual]`

Get configuration file name.

Implements iConfigFile.

virtual float csConfigFile::GetFloat | ( | const char * | Key,
|  | float | Def = `0.0`
| ) |  | const`[virtual]`

Get a float value from the configuration.

Implements iConfigFile.

virtual int csConfigFile::GetInt | ( | const char * | Key,
|  | int | Def
| ) |  | const`[virtual]`

Get an integer value from the configuration.

Implements iConfigFile.

virtual const char* csConfigFile::GetStr | ( | const char * | Key,
|  | const char * | Def = `""`
| ) |  | const`[virtual]`

Get a string value from the configuration.

Implements iConfigFile.

virtual csPtr<iStringArray> csConfigFile::GetTuple | ( | const char * | Key | ) | const`[virtual]`

Get a tuple set from the configuration.

Implements iConfigFile.

virtual iVFS* csConfigFile::GetVFS | ( |  | ) | const`[virtual]`

Get the VFS object on which this file is stored (if any).

Returns 0 if this file resides within the real (non-VFS) filesystem.

Implements iConfigFile.

virtual bool csConfigFile::IsEmpty | ( |  | ) | const`[virtual]`

Is the configuration object empty?

virtual bool csConfigFile::KeyExists | ( | const char * | Key | ) | const`[virtual]`

Test if a key exists.

Implements iConfigFile.

virtual bool csConfigFile::Load | ( | const char * | iFileName,
|  | iVFS * | = `0`,
|  | bool | Merge = `false`,
|  | bool | NewWins = `true`
| ) |  | `[virtual]`

Load a configuration file.

If the file resides in a real filesystem, rather than a VFS filesystem, then pass 0 for the VFS argument.

You can set the Merge flag to merge the newly loaded configuration information into the existing information. If you do so, nothing will happen if the named file doesn't exist. The NewWins flag determines the behavior in case of configuration key conflicts. If true, then the new configuration value replaces the old for that key. If false, then the old value is kept, and the new value is ignored. The recorded file name will be set to the name of the newly loaded file if the Merge flag is false; otherwise it will retain the old name.

Implements iConfigFile.

virtual void csConfigFile::LoadFromBuffer | ( | const char * | Filedata,
|  | bool | overwrite
| ) |  | `[virtual]`

Load the configuration from a data buffer and add it to the current configuration.

This may modify the contents of the file buffer but will not delete it. This function will set the dirty flag if any options have been added or modified.

virtual void csConfigFile::ParseCommandLine | ( | iCommandLineParser * | cmdline,
|  | iVFS * | vfs,
|  | bool | Merge = `false`,
|  | bool | NewWins = `true`
| ) |  | `[virtual]`

Parse the command line for configuration options.

Recognized are the `-cfgset` parameters, which sets a single setting, and `-cfgfile`, which reads settings from the specified file.

The meanings of the `vfs`, `Merge` and `NewWins` arguments are the same as for Load().

virtual bool csConfigFile::Save | ( |  | ) | `[virtual]`

Save configuration to the same place from which it was loaded.

Returns true if the save operation succeeded.

Implements iConfigFile.

virtual bool csConfigFile::Save | ( | const char * | iFileName,
|  | iVFS * | = `0`
| ) |  | `[virtual]`

Save configuration into the given file (on VFS or on the physical filesystem).

If the second parameter is skipped, the file will be written to the physical filesystem, otherwise it is stored on given VFS filesystem. This method does not change the internally stored file name.

Implements iConfigFile.

virtual void csConfigFile::SetBool | ( | const char * | Key,
|  | bool | Value
| ) |  | `[virtual]`

Set a boolean value.

Implements iConfigFile.

virtual bool csConfigFile::SetComment | ( | const char * | Key,
|  | const char * | Text
| ) |  | `[virtual]`

Set the comment for given key.

In addition to an actual comment, you can use "" for Text to place an empty comment line before this key, or 0 to remove the comment entirely. The comment may contain newline characters. Returns false if the key does not exist.

Implements iConfigFile.

virtual void csConfigFile::SetEOFComment | ( | const char * | Text | ) | `[virtual]`

set the final comment at the end of the configuration file

Implements iConfigFile.

virtual void csConfigFile::SetFileName | ( | const char * | ,
|  | iVFS * |
| ) |  | `[virtual]`

Set config file name.

You can use this if you want Save() to write to another file. This will set the dirty flag.

Implements iConfigFile.

virtual void csConfigFile::SetFloat | ( | const char * | Key,
|  | float | Value
| ) |  | `[virtual]`

Set a floating-point value.

Implements iConfigFile.

virtual void csConfigFile::SetInt | ( | const char * | Key,
|  | int | Value
| ) |  | `[virtual]`

Set an integer value.

Implements iConfigFile.

virtual void csConfigFile::SetStr | ( | const char * | Key,
|  | const char * | Val
| ) |  | `[virtual]`

Set an null-terminated string value.

Implements iConfigFile.

virtual void csConfigFile::SetTuple | ( | const char * | Key,
|  | iStringArray * | Value
| ) |  | `[virtual]`

Set a tuple value.

Implements iConfigFile.

virtual bool csConfigFile::SubsectionExists | ( | const char * | Subsection | ) | const`[virtual]`

Test if at least one key exists with the given Subsection prefix.

Implements iConfigFile.

The documentation for this class was generated from the following file:

- csutil/cfgfile.h